from math import asin, sin, cos, pi, sqrt

# chemin qui mène à votre répertoire de travail
PATH = "/DONNEES/Enseignement/2018-19/SNT/"
# nom du fichier xml téléchargé depuis OpenStreetMap
fname = "TP6-mapEcrins.osm"


## A PARTIR D'ICI (-> ligne 90) NE PAS MODIFIER 

def latlon(ligne):
    lat = ligne.split('lat="')[1]
    lat = float( lat.split('"')[0] ) 
    lon = ligne.split('lon="')[1]
    lon = float( lon.split('"')[0] )
    return lat, lon

def avance(file, line):
    """une ligne non-informative est du type <node … />
    une multi-ligne informative est du type <node … > <tag … /> … </node> 
    """
    if not ( "<node " in line ) or "/>" in line : # ligne non-informative
        return False, file.readline()
    i = 0
    lines = [ line ]
    lines.append( file.readline() )
    i += 1
    if "<tag" in lines[i] : # multi-ligne informative
        nom, ele, type = "", "", ""
        while not( "</node>" in lines[i] ):
            if 'k="name"' in lines[i] : # recuperation du nom
                nom = lines[i].split('v=')[1]
                nom = nom.split('/>')[0]
            elif 'k="ele"' in lines[i] : # recuperation de l'elevation
                ele = lines[i].split('v="')[1]
                ele = ele.split('"/>')[0]
                ele = ele.split(';')[0] # incertitude elevation
                ele = float( ele.split('m')[0] ) # unite specifiee
                # a ameliorer avec un sed/[0-9.]+/ 
            elif ( 'k="place"' in lines[i] ) or ( 'k="natural"' in lines[i] ) : # recuperation des villages ou éléments naturels (cols, sommets, ...)
                type = lines[i].split('v=')[1]
                type = type.split('/>')[0]  # hamlet <-> hameau
            lines.append( file.readline() )
            i += 1
        if nom != "" and type != "" :   # si le noeud est un element remarquable
            lat, lon = latlon(lines[0])
            val = [ nom, type, lat, lon, ele]
            return True, val
    return False, lines[-1]

def lectureFichier(fnom):
    file = open(fnom, "r", encoding='utf_8')
    line = ""
    liste = []
    while not ("<way" in line ) :   # fin définition des noeuds avec le début définition des chemins <way>
        bool, val = avance(file, line)
        if bool :
            liste.append(val)
            line=""
        else :
            line = val
    print(line) # derniere ligne lue
    file.close()
    return liste

def ecritureCSV(liste, fnom):
    file = open(fnom, "w", encoding='utf_8')
    file.write('Nom, Type, Latitude N, Longitude E, Altitude \n')
    for e in liste :
        file.write(e[0]+','+e[1]+','+str(e[2])+','+str(e[3])+','+str(e[4])+'\n')
    file.close()

LL = lectureFichier(PATH+fname)
# creation du fichier .csv contenant tous les noeuds villes, sommets, cols, etc.
ffname = "TP6-mapEcrins.csv"
ecritureCSV(LL,PATH+ffname)

##

def afficherHameaux(liste):
    """ affiche les elements de liste qui sont du type "hamlet"
    """
    for e in liste:
        if e[1] == '"hamlet"' :
            print(e)

afficherHameaux(LL)

## MODIFICATION DE NOUVEAU POSSIBLE

def afficherSommets(liste):
    1


